//-----------------------------------------------------------------------------
//
// Endurance R/C PCTx/Servo Controller Web Interface v1.2
// Only use with ServoCommander v1.4
// Copyright 2009 Endurance R/C
//
//-----------------------------------------------------------------------------

#pragma once
#include "controller.h"
#include <windows.h>
#include "stdafx.h"
#using <System.dll>
#include <fstream>
#include <string>
#include <iostream>
#include <sstream>
#include <stdlib.h>

namespace serverGui {

	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System;
	using namespace System::IO;
	using namespace System::Net;
	using namespace System::Net::Sockets;
	using namespace System::Text;
	using namespace System::Threading;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace std;
	using namespace System::Runtime::InteropServices;

	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
		}

	protected:
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}

	private: Thread ^trd;										//main worker thread
	private: bool threadRunning;
	private: bool clientConnected;
	private: controller *c;	
	private: TcpClient^ client;

	private: System::ComponentModel::IContainer^  components;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::HScrollBar^  hScrollBar1;
	private: System::Windows::Forms::HScrollBar^  hScrollBar2;
	private: System::Windows::Forms::HScrollBar^  hScrollBar3;
	private: System::Windows::Forms::HScrollBar^  hScrollBar4;
	private: System::Windows::Forms::HScrollBar^  hScrollBar5;
	private: System::Windows::Forms::HScrollBar^  hScrollBar6;
	private: System::Windows::Forms::HScrollBar^  hScrollBar7;
	private: System::Windows::Forms::HScrollBar^  hScrollBar8;
	private: System::Windows::Forms::HScrollBar^  hScrollBar9;
	private: System::Windows::Forms::Label^  label11;
	private: System::Windows::Forms::Label^  label10;
	private: System::Windows::Forms::Label^  label9;
	private: System::Windows::Forms::Label^  label8;
	private: System::Windows::Forms::Label^  label7;
	private: System::Windows::Forms::Label^  label6;
	private: System::Windows::Forms::Label^  label5;
	private: System::Windows::Forms::Label^  label4;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::GroupBox^  groupBox1;
	private: System::Windows::Forms::ComboBox^  comboBox1;
	private: System::Windows::Forms::Label^  label22;
	private: System::Windows::Forms::Label^  label21;
	private: System::Windows::Forms::TextBox^  textBox1;
	private: System::Windows::Forms::Label^  label23;
	private: System::Windows::Forms::Label^  label24;
	private: System::Windows::Forms::Label^  label25;
	private: System::Windows::Forms::Button^  button2;
	private: System::Windows::Forms::Button^  button1;
	private: System::Windows::Forms::Label^  label26;
	private: System::Windows::Forms::HScrollBar^  hScrollBar10;
	private: System::Windows::Forms::Label^  label28;
	private: System::Windows::Forms::HScrollBar^  hScrollBar11;
	private: System::Windows::Forms::Label^  label30;
	private: System::Windows::Forms::HScrollBar^  hScrollBar12;
	private: System::Windows::Forms::Label^  label32;
	private: System::Windows::Forms::HScrollBar^  hScrollBar13;
	private: System::Windows::Forms::Label^  label34;
	private: System::Windows::Forms::HScrollBar^  hScrollBar14;
	private: System::Windows::Forms::Label^  label36;
	private: System::Windows::Forms::HScrollBar^  hScrollBar15;
	private: System::Windows::Forms::Label^  label38;
	private: System::Windows::Forms::HScrollBar^  hScrollBar16;
	private: System::Windows::Forms::Label^  label40;
	private: System::Windows::Forms::HScrollBar^  hScrollBar17;
	private: System::Windows::Forms::Label^  label42;
	private: System::Windows::Forms::HScrollBar^  hScrollBar18;
	private: System::Windows::Forms::Label^  label44;
	private: System::Windows::Forms::HScrollBar^  hScrollBar19;
	private: System::Windows::Forms::Label^  label46;
	private: System::Windows::Forms::HScrollBar^  hScrollBar20;
	private: System::Windows::Forms::Label^  label48;
	private: System::Windows::Forms::HScrollBar^  hScrollBar21;
	private: System::Windows::Forms::Label^  label50;
	private: System::Windows::Forms::HScrollBar^  hScrollBar22;
	private: System::Windows::Forms::Label^  label52;
	private: System::Windows::Forms::HScrollBar^  hScrollBar23;
	private: System::Windows::Forms::Label^  label54;
	private: System::Windows::Forms::HScrollBar^  hScrollBar24;
	private: System::Windows::Forms::Label^  label56;
	private: System::Windows::Forms::HScrollBar^  hScrollBar25;
	private: System::Windows::Forms::Timer^  timer1;
	private: System::Windows::Forms::Timer^  deviceChecker;
	private: System::Windows::Forms::Label^  label17;
	private: System::Windows::Forms::Panel^  panel1;
	private: System::Windows::Forms::Label^  label12;
	private: System::Windows::Forms::Label^  label13;
	private: System::Windows::Forms::Label^  label14;
	private: System::Windows::Forms::Label^  label15;
	private: System::Windows::Forms::Label^  label16;
	private: System::Windows::Forms::Label^  label18;
	private: System::Windows::Forms::Label^  label19;
	private: System::Windows::Forms::Label^  label20;
	private: System::Windows::Forms::Label^  label27;
	private: System::Windows::Forms::Label^  label29;
	private: System::Windows::Forms::Label^  label31;
	private: System::Windows::Forms::Label^  label33;
	private: System::Windows::Forms::Label^  label35;
	private: System::Windows::Forms::Label^  label37;
	private: System::Windows::Forms::Label^  label39;
	private: System::Windows::Forms::Label^  label41;
	private: System::Windows::Forms::Label^  label43;
	private: System::Windows::Forms::Label^  label45;
	private: System::Windows::Forms::Label^  label47;
	private: System::Windows::Forms::Label^  label49;
	private: System::Windows::Forms::Label^  label51;
	private: System::Windows::Forms::Label^  label53;
	private: System::Windows::Forms::Label^  label55;
	private: System::Windows::Forms::Label^  label57;
	private: System::Windows::Forms::Label^  label58;
	private: System::Windows::Forms::Panel^  panel2;
	private: System::Windows::Forms::Panel^  panel3;



	private: System::Windows::Forms::Panel^  panel4;

#pragma region Windows Form Designer generated code
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(Form1::typeid));
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar1 = (gcnew System::Windows::Forms::HScrollBar());
			this->hScrollBar2 = (gcnew System::Windows::Forms::HScrollBar());
			this->hScrollBar3 = (gcnew System::Windows::Forms::HScrollBar());
			this->hScrollBar4 = (gcnew System::Windows::Forms::HScrollBar());
			this->hScrollBar5 = (gcnew System::Windows::Forms::HScrollBar());
			this->hScrollBar6 = (gcnew System::Windows::Forms::HScrollBar());
			this->hScrollBar7 = (gcnew System::Windows::Forms::HScrollBar());
			this->hScrollBar8 = (gcnew System::Windows::Forms::HScrollBar());
			this->hScrollBar9 = (gcnew System::Windows::Forms::HScrollBar());
			this->label11 = (gcnew System::Windows::Forms::Label());
			this->label10 = (gcnew System::Windows::Forms::Label());
			this->label9 = (gcnew System::Windows::Forms::Label());
			this->label8 = (gcnew System::Windows::Forms::Label());
			this->label7 = (gcnew System::Windows::Forms::Label());
			this->label6 = (gcnew System::Windows::Forms::Label());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
			this->comboBox1 = (gcnew System::Windows::Forms::ComboBox());
			this->label22 = (gcnew System::Windows::Forms::Label());
			this->label21 = (gcnew System::Windows::Forms::Label());
			this->textBox1 = (gcnew System::Windows::Forms::TextBox());
			this->button1 = (gcnew System::Windows::Forms::Button());
			this->button2 = (gcnew System::Windows::Forms::Button());
			this->label23 = (gcnew System::Windows::Forms::Label());
			this->label24 = (gcnew System::Windows::Forms::Label());
			this->label25 = (gcnew System::Windows::Forms::Label());
			this->label26 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar10 = (gcnew System::Windows::Forms::HScrollBar());
			this->label28 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar11 = (gcnew System::Windows::Forms::HScrollBar());
			this->label30 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar12 = (gcnew System::Windows::Forms::HScrollBar());
			this->label32 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar13 = (gcnew System::Windows::Forms::HScrollBar());
			this->label34 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar14 = (gcnew System::Windows::Forms::HScrollBar());
			this->label36 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar15 = (gcnew System::Windows::Forms::HScrollBar());
			this->label38 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar16 = (gcnew System::Windows::Forms::HScrollBar());
			this->label40 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar17 = (gcnew System::Windows::Forms::HScrollBar());
			this->label42 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar18 = (gcnew System::Windows::Forms::HScrollBar());
			this->label44 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar19 = (gcnew System::Windows::Forms::HScrollBar());
			this->label46 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar20 = (gcnew System::Windows::Forms::HScrollBar());
			this->label48 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar21 = (gcnew System::Windows::Forms::HScrollBar());
			this->label50 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar22 = (gcnew System::Windows::Forms::HScrollBar());
			this->label52 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar23 = (gcnew System::Windows::Forms::HScrollBar());
			this->label54 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar24 = (gcnew System::Windows::Forms::HScrollBar());
			this->label56 = (gcnew System::Windows::Forms::Label());
			this->hScrollBar25 = (gcnew System::Windows::Forms::HScrollBar());
			this->timer1 = (gcnew System::Windows::Forms::Timer(this->components));
			this->deviceChecker = (gcnew System::Windows::Forms::Timer(this->components));
			this->label17 = (gcnew System::Windows::Forms::Label());
			this->panel1 = (gcnew System::Windows::Forms::Panel());
			this->label12 = (gcnew System::Windows::Forms::Label());
			this->label13 = (gcnew System::Windows::Forms::Label());
			this->label14 = (gcnew System::Windows::Forms::Label());
			this->label15 = (gcnew System::Windows::Forms::Label());
			this->label16 = (gcnew System::Windows::Forms::Label());
			this->label18 = (gcnew System::Windows::Forms::Label());
			this->label19 = (gcnew System::Windows::Forms::Label());
			this->label20 = (gcnew System::Windows::Forms::Label());
			this->label27 = (gcnew System::Windows::Forms::Label());
			this->label29 = (gcnew System::Windows::Forms::Label());
			this->label31 = (gcnew System::Windows::Forms::Label());
			this->label33 = (gcnew System::Windows::Forms::Label());
			this->label35 = (gcnew System::Windows::Forms::Label());
			this->label37 = (gcnew System::Windows::Forms::Label());
			this->label39 = (gcnew System::Windows::Forms::Label());
			this->label41 = (gcnew System::Windows::Forms::Label());
			this->label43 = (gcnew System::Windows::Forms::Label());
			this->label45 = (gcnew System::Windows::Forms::Label());
			this->label47 = (gcnew System::Windows::Forms::Label());
			this->label49 = (gcnew System::Windows::Forms::Label());
			this->label51 = (gcnew System::Windows::Forms::Label());
			this->label53 = (gcnew System::Windows::Forms::Label());
			this->label55 = (gcnew System::Windows::Forms::Label());
			this->label57 = (gcnew System::Windows::Forms::Label());
			this->label58 = (gcnew System::Windows::Forms::Label());
			this->panel2 = (gcnew System::Windows::Forms::Panel());
			this->panel3 = (gcnew System::Windows::Forms::Panel());
			this->panel4 = (gcnew System::Windows::Forms::Panel());
			this->groupBox1->SuspendLayout();
			this->panel1->SuspendLayout();
			this->panel2->SuspendLayout();
			this->panel3->SuspendLayout();
			this->panel4->SuspendLayout();
			this->SuspendLayout();
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(11, 90);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(69, 13);
			this->label1->TabIndex = 0;
			this->label1->Text = L"Client Status:";
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(78, 90);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(79, 13);
			this->label2->TabIndex = 1;
			this->label2->Text = L"Not Connected";
			// 
			// hScrollBar1
			// 
			this->hScrollBar1->LargeChange = 1;
			this->hScrollBar1->Location = System::Drawing::Point(40, 0);
			this->hScrollBar1->Maximum = 255;
			this->hScrollBar1->Minimum = 1;
			this->hScrollBar1->Name = L"hScrollBar1";
			this->hScrollBar1->Size = System::Drawing::Size(228, 16);
			this->hScrollBar1->TabIndex = 4;
			this->hScrollBar1->Value = 150;
			// 
			// hScrollBar2
			// 
			this->hScrollBar2->LargeChange = 1;
			this->hScrollBar2->Location = System::Drawing::Point(40, 29);
			this->hScrollBar2->Maximum = 255;
			this->hScrollBar2->Minimum = 1;
			this->hScrollBar2->Name = L"hScrollBar2";
			this->hScrollBar2->Size = System::Drawing::Size(228, 16);
			this->hScrollBar2->TabIndex = 5;
			this->hScrollBar2->Value = 150;
			// 
			// hScrollBar3
			// 
			this->hScrollBar3->LargeChange = 1;
			this->hScrollBar3->Location = System::Drawing::Point(40, 58);
			this->hScrollBar3->Maximum = 255;
			this->hScrollBar3->Minimum = 1;
			this->hScrollBar3->Name = L"hScrollBar3";
			this->hScrollBar3->Size = System::Drawing::Size(228, 16);
			this->hScrollBar3->TabIndex = 6;
			this->hScrollBar3->Value = 150;
			// 
			// hScrollBar4
			// 
			this->hScrollBar4->LargeChange = 1;
			this->hScrollBar4->Location = System::Drawing::Point(40, 87);
			this->hScrollBar4->Maximum = 255;
			this->hScrollBar4->Minimum = 1;
			this->hScrollBar4->Name = L"hScrollBar4";
			this->hScrollBar4->Size = System::Drawing::Size(228, 16);
			this->hScrollBar4->TabIndex = 7;
			this->hScrollBar4->Value = 150;
			// 
			// hScrollBar5
			// 
			this->hScrollBar5->LargeChange = 1;
			this->hScrollBar5->Location = System::Drawing::Point(40, 116);
			this->hScrollBar5->Maximum = 255;
			this->hScrollBar5->Minimum = 1;
			this->hScrollBar5->Name = L"hScrollBar5";
			this->hScrollBar5->Size = System::Drawing::Size(228, 16);
			this->hScrollBar5->TabIndex = 8;
			this->hScrollBar5->Value = 150;
			// 
			// hScrollBar6
			// 
			this->hScrollBar6->LargeChange = 1;
			this->hScrollBar6->Location = System::Drawing::Point(40, 145);
			this->hScrollBar6->Maximum = 255;
			this->hScrollBar6->Minimum = 1;
			this->hScrollBar6->Name = L"hScrollBar6";
			this->hScrollBar6->Size = System::Drawing::Size(228, 16);
			this->hScrollBar6->TabIndex = 9;
			this->hScrollBar6->Value = 150;
			// 
			// hScrollBar7
			// 
			this->hScrollBar7->LargeChange = 1;
			this->hScrollBar7->Location = System::Drawing::Point(40, 174);
			this->hScrollBar7->Maximum = 255;
			this->hScrollBar7->Minimum = 1;
			this->hScrollBar7->Name = L"hScrollBar7";
			this->hScrollBar7->Size = System::Drawing::Size(228, 16);
			this->hScrollBar7->TabIndex = 10;
			this->hScrollBar7->Value = 150;
			// 
			// hScrollBar8
			// 
			this->hScrollBar8->LargeChange = 1;
			this->hScrollBar8->Location = System::Drawing::Point(40, 203);
			this->hScrollBar8->Maximum = 255;
			this->hScrollBar8->Minimum = 1;
			this->hScrollBar8->Name = L"hScrollBar8";
			this->hScrollBar8->Size = System::Drawing::Size(228, 16);
			this->hScrollBar8->TabIndex = 11;
			this->hScrollBar8->Value = 150;
			// 
			// hScrollBar9
			// 
			this->hScrollBar9->LargeChange = 1;
			this->hScrollBar9->Location = System::Drawing::Point(42, -1);
			this->hScrollBar9->Maximum = 255;
			this->hScrollBar9->Minimum = 1;
			this->hScrollBar9->Name = L"hScrollBar9";
			this->hScrollBar9->Size = System::Drawing::Size(228, 16);
			this->hScrollBar9->TabIndex = 12;
			this->hScrollBar9->Value = 150;
			// 
			// label11
			// 
			this->label11->AutoSize = true;
			this->label11->Location = System::Drawing::Point(6, 2);
			this->label11->Name = L"label11";
			this->label11->Size = System::Drawing::Size(28, 13);
			this->label11->TabIndex = 49;
			this->label11->Text = L"CH9";
			// 
			// label10
			// 
			this->label10->AutoSize = true;
			this->label10->Location = System::Drawing::Point(4, 206);
			this->label10->Name = L"label10";
			this->label10->Size = System::Drawing::Size(28, 13);
			this->label10->TabIndex = 48;
			this->label10->Text = L"CH8";
			// 
			// label9
			// 
			this->label9->AutoSize = true;
			this->label9->Location = System::Drawing::Point(4, 177);
			this->label9->Name = L"label9";
			this->label9->Size = System::Drawing::Size(28, 13);
			this->label9->TabIndex = 47;
			this->label9->Text = L"CH7";
			// 
			// label8
			// 
			this->label8->AutoSize = true;
			this->label8->Location = System::Drawing::Point(4, 148);
			this->label8->Name = L"label8";
			this->label8->Size = System::Drawing::Size(28, 13);
			this->label8->TabIndex = 46;
			this->label8->Text = L"CH6";
			// 
			// label7
			// 
			this->label7->AutoSize = true;
			this->label7->Location = System::Drawing::Point(4, 117);
			this->label7->Name = L"label7";
			this->label7->Size = System::Drawing::Size(28, 13);
			this->label7->TabIndex = 45;
			this->label7->Text = L"CH5";
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->Location = System::Drawing::Point(4, 90);
			this->label6->Name = L"label6";
			this->label6->Size = System::Drawing::Size(28, 13);
			this->label6->TabIndex = 44;
			this->label6->Text = L"CH4";
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Location = System::Drawing::Point(4, 61);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(28, 13);
			this->label5->TabIndex = 43;
			this->label5->Text = L"CH3";
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Location = System::Drawing::Point(4, 32);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(28, 13);
			this->label4->TabIndex = 42;
			this->label4->Text = L"CH2";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(4, 3);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(28, 13);
			this->label3->TabIndex = 41;
			this->label3->Text = L"CH1";
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->comboBox1);
			this->groupBox1->Controls->Add(this->label22);
			this->groupBox1->Controls->Add(this->label21);
			this->groupBox1->Controls->Add(this->textBox1);
			this->groupBox1->Controls->Add(this->button1);
			this->groupBox1->Controls->Add(this->button2);
			this->groupBox1->Controls->Add(this->label1);
			this->groupBox1->Controls->Add(this->label2);
			this->groupBox1->Location = System::Drawing::Point(3, 3);
			this->groupBox1->Name = L"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(295, 116);
			this->groupBox1->TabIndex = 50;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = L"Server Settings";
			// 
			// comboBox1
			// 
			this->comboBox1->FormattingEnabled = true;
			this->comboBox1->Location = System::Drawing::Point(46, 46);
			this->comboBox1->Name = L"comboBox1";
			this->comboBox1->Size = System::Drawing::Size(160, 21);
			this->comboBox1->TabIndex = 44;
			// 
			// label22
			// 
			this->label22->AutoSize = true;
			this->label22->Location = System::Drawing::Point(11, 49);
			this->label22->Name = L"label22";
			this->label22->Size = System::Drawing::Size(20, 13);
			this->label22->TabIndex = 43;
			this->label22->Text = L"IP:";
			// 
			// label21
			// 
			this->label21->AutoSize = true;
			this->label21->Location = System::Drawing::Point(11, 26);
			this->label21->Name = L"label21";
			this->label21->Size = System::Drawing::Size(29, 13);
			this->label21->TabIndex = 42;
			this->label21->Text = L"Port:";
			// 
			// textBox1
			// 
			this->textBox1->Location = System::Drawing::Point(46, 23);
			this->textBox1->Name = L"textBox1";
			this->textBox1->Size = System::Drawing::Size(160, 20);
			this->textBox1->TabIndex = 0;
			this->textBox1->Text = L"81";
			// 
			// button1
			// 
			this->button1->Location = System::Drawing::Point(215, 28);
			this->button1->Name = L"button1";
			this->button1->Size = System::Drawing::Size(74, 27);
			this->button1->TabIndex = 54;
			this->button1->Text = L"Start";
			this->button1->UseVisualStyleBackColor = true;
			this->button1->Click += gcnew System::EventHandler(this, &Form1::button1_Click);
			// 
			// button2
			// 
			this->button2->Enabled = false;
			this->button2->Location = System::Drawing::Point(215, 64);
			this->button2->Name = L"button2";
			this->button2->Size = System::Drawing::Size(74, 27);
			this->button2->TabIndex = 55;
			this->button2->Text = L"Stop";
			this->button2->UseVisualStyleBackColor = true;
			this->button2->Visible = false;
			this->button2->Click += gcnew System::EventHandler(this, &Form1::button2_Click);
			// 
			// label23
			// 
			this->label23->AutoSize = true;
			this->label23->Location = System::Drawing::Point(46, 130);
			this->label23->Name = L"label23";
			this->label23->Size = System::Drawing::Size(79, 13);
			this->label23->TabIndex = 51;
			this->label23->Text = L"Output Device:";
			// 
			// label24
			// 
			this->label24->AutoSize = true;
			this->label24->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"label24.Image")));
			this->label24->Location = System::Drawing::Point(129, 130);
			this->label24->Name = L"label24";
			this->label24->Size = System::Drawing::Size(13, 13);
			this->label24->TabIndex = 52;
			this->label24->Text = L"  ";
			// 
			// label25
			// 
			this->label25->AutoSize = true;
			this->label25->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"label25.Image")));
			this->label25->Location = System::Drawing::Point(129, 130);
			this->label25->Name = L"label25";
			this->label25->Size = System::Drawing::Size(13, 13);
			this->label25->TabIndex = 53;
			this->label25->Text = L"  ";
			// 
			// label26
			// 
			this->label26->AutoSize = true;
			this->label26->Location = System::Drawing::Point(6, 31);
			this->label26->Name = L"label26";
			this->label26->Size = System::Drawing::Size(34, 13);
			this->label26->TabIndex = 58;
			this->label26->Text = L"CH10";
			// 
			// hScrollBar10
			// 
			this->hScrollBar10->LargeChange = 1;
			this->hScrollBar10->Location = System::Drawing::Point(42, 28);
			this->hScrollBar10->Maximum = 255;
			this->hScrollBar10->Minimum = 1;
			this->hScrollBar10->Name = L"hScrollBar10";
			this->hScrollBar10->Size = System::Drawing::Size(228, 16);
			this->hScrollBar10->TabIndex = 56;
			this->hScrollBar10->Value = 150;
			// 
			// label28
			// 
			this->label28->AutoSize = true;
			this->label28->Location = System::Drawing::Point(6, 60);
			this->label28->Name = L"label28";
			this->label28->Size = System::Drawing::Size(34, 13);
			this->label28->TabIndex = 61;
			this->label28->Text = L"CH11";
			// 
			// hScrollBar11
			// 
			this->hScrollBar11->LargeChange = 1;
			this->hScrollBar11->Location = System::Drawing::Point(42, 57);
			this->hScrollBar11->Maximum = 255;
			this->hScrollBar11->Minimum = 1;
			this->hScrollBar11->Name = L"hScrollBar11";
			this->hScrollBar11->Size = System::Drawing::Size(228, 16);
			this->hScrollBar11->TabIndex = 59;
			this->hScrollBar11->Value = 150;
			// 
			// label30
			// 
			this->label30->AutoSize = true;
			this->label30->Location = System::Drawing::Point(6, 89);
			this->label30->Name = L"label30";
			this->label30->Size = System::Drawing::Size(34, 13);
			this->label30->TabIndex = 64;
			this->label30->Text = L"CH12";
			// 
			// hScrollBar12
			// 
			this->hScrollBar12->LargeChange = 1;
			this->hScrollBar12->Location = System::Drawing::Point(42, 86);
			this->hScrollBar12->Maximum = 255;
			this->hScrollBar12->Minimum = 1;
			this->hScrollBar12->Name = L"hScrollBar12";
			this->hScrollBar12->Size = System::Drawing::Size(228, 16);
			this->hScrollBar12->TabIndex = 62;
			this->hScrollBar12->Value = 150;
			// 
			// label32
			// 
			this->label32->AutoSize = true;
			this->label32->Location = System::Drawing::Point(6, 118);
			this->label32->Name = L"label32";
			this->label32->Size = System::Drawing::Size(34, 13);
			this->label32->TabIndex = 67;
			this->label32->Text = L"CH13";
			// 
			// hScrollBar13
			// 
			this->hScrollBar13->LargeChange = 1;
			this->hScrollBar13->Location = System::Drawing::Point(42, 115);
			this->hScrollBar13->Maximum = 255;
			this->hScrollBar13->Minimum = 1;
			this->hScrollBar13->Name = L"hScrollBar13";
			this->hScrollBar13->Size = System::Drawing::Size(228, 16);
			this->hScrollBar13->TabIndex = 65;
			this->hScrollBar13->Value = 150;
			// 
			// label34
			// 
			this->label34->AutoSize = true;
			this->label34->Location = System::Drawing::Point(6, 147);
			this->label34->Name = L"label34";
			this->label34->Size = System::Drawing::Size(34, 13);
			this->label34->TabIndex = 70;
			this->label34->Text = L"CH14";
			// 
			// hScrollBar14
			// 
			this->hScrollBar14->LargeChange = 1;
			this->hScrollBar14->Location = System::Drawing::Point(42, 144);
			this->hScrollBar14->Maximum = 255;
			this->hScrollBar14->Minimum = 1;
			this->hScrollBar14->Name = L"hScrollBar14";
			this->hScrollBar14->Size = System::Drawing::Size(228, 16);
			this->hScrollBar14->TabIndex = 68;
			this->hScrollBar14->Value = 150;
			// 
			// label36
			// 
			this->label36->AutoSize = true;
			this->label36->Location = System::Drawing::Point(6, 176);
			this->label36->Name = L"label36";
			this->label36->Size = System::Drawing::Size(34, 13);
			this->label36->TabIndex = 73;
			this->label36->Text = L"CH15";
			// 
			// hScrollBar15
			// 
			this->hScrollBar15->LargeChange = 1;
			this->hScrollBar15->Location = System::Drawing::Point(42, 173);
			this->hScrollBar15->Maximum = 255;
			this->hScrollBar15->Minimum = 1;
			this->hScrollBar15->Name = L"hScrollBar15";
			this->hScrollBar15->Size = System::Drawing::Size(228, 16);
			this->hScrollBar15->TabIndex = 71;
			this->hScrollBar15->Value = 150;
			// 
			// label38
			// 
			this->label38->AutoSize = true;
			this->label38->Location = System::Drawing::Point(3, 3);
			this->label38->Name = L"label38";
			this->label38->Size = System::Drawing::Size(34, 13);
			this->label38->TabIndex = 76;
			this->label38->Text = L"CH16";
			// 
			// hScrollBar16
			// 
			this->hScrollBar16->LargeChange = 1;
			this->hScrollBar16->Location = System::Drawing::Point(40, 0);
			this->hScrollBar16->Maximum = 255;
			this->hScrollBar16->Minimum = 1;
			this->hScrollBar16->Name = L"hScrollBar16";
			this->hScrollBar16->Size = System::Drawing::Size(228, 16);
			this->hScrollBar16->TabIndex = 74;
			this->hScrollBar16->Value = 150;
			// 
			// label40
			// 
			this->label40->AutoSize = true;
			this->label40->Location = System::Drawing::Point(3, 32);
			this->label40->Name = L"label40";
			this->label40->Size = System::Drawing::Size(34, 13);
			this->label40->TabIndex = 79;
			this->label40->Text = L"CH17";
			// 
			// hScrollBar17
			// 
			this->hScrollBar17->LargeChange = 1;
			this->hScrollBar17->Location = System::Drawing::Point(40, 29);
			this->hScrollBar17->Maximum = 255;
			this->hScrollBar17->Minimum = 1;
			this->hScrollBar17->Name = L"hScrollBar17";
			this->hScrollBar17->Size = System::Drawing::Size(228, 16);
			this->hScrollBar17->TabIndex = 77;
			this->hScrollBar17->Value = 150;
			// 
			// label42
			// 
			this->label42->AutoSize = true;
			this->label42->Location = System::Drawing::Point(3, 61);
			this->label42->Name = L"label42";
			this->label42->Size = System::Drawing::Size(34, 13);
			this->label42->TabIndex = 82;
			this->label42->Text = L"CH18";
			// 
			// hScrollBar18
			// 
			this->hScrollBar18->LargeChange = 1;
			this->hScrollBar18->Location = System::Drawing::Point(40, 58);
			this->hScrollBar18->Maximum = 255;
			this->hScrollBar18->Minimum = 1;
			this->hScrollBar18->Name = L"hScrollBar18";
			this->hScrollBar18->Size = System::Drawing::Size(228, 16);
			this->hScrollBar18->TabIndex = 80;
			this->hScrollBar18->Value = 150;
			// 
			// label44
			// 
			this->label44->AutoSize = true;
			this->label44->Location = System::Drawing::Point(3, 90);
			this->label44->Name = L"label44";
			this->label44->Size = System::Drawing::Size(34, 13);
			this->label44->TabIndex = 85;
			this->label44->Text = L"CH19";
			// 
			// hScrollBar19
			// 
			this->hScrollBar19->LargeChange = 1;
			this->hScrollBar19->Location = System::Drawing::Point(40, 87);
			this->hScrollBar19->Maximum = 255;
			this->hScrollBar19->Minimum = 1;
			this->hScrollBar19->Name = L"hScrollBar19";
			this->hScrollBar19->Size = System::Drawing::Size(228, 16);
			this->hScrollBar19->TabIndex = 83;
			this->hScrollBar19->Value = 150;
			// 
			// label46
			// 
			this->label46->AutoSize = true;
			this->label46->Location = System::Drawing::Point(3, 119);
			this->label46->Name = L"label46";
			this->label46->Size = System::Drawing::Size(34, 13);
			this->label46->TabIndex = 88;
			this->label46->Text = L"CH20";
			// 
			// hScrollBar20
			// 
			this->hScrollBar20->LargeChange = 1;
			this->hScrollBar20->Location = System::Drawing::Point(40, 116);
			this->hScrollBar20->Maximum = 255;
			this->hScrollBar20->Minimum = 1;
			this->hScrollBar20->Name = L"hScrollBar20";
			this->hScrollBar20->Size = System::Drawing::Size(228, 16);
			this->hScrollBar20->TabIndex = 86;
			this->hScrollBar20->Value = 150;
			// 
			// label48
			// 
			this->label48->AutoSize = true;
			this->label48->Location = System::Drawing::Point(3, 148);
			this->label48->Name = L"label48";
			this->label48->Size = System::Drawing::Size(34, 13);
			this->label48->TabIndex = 91;
			this->label48->Text = L"CH21";
			// 
			// hScrollBar21
			// 
			this->hScrollBar21->LargeChange = 1;
			this->hScrollBar21->Location = System::Drawing::Point(40, 142);
			this->hScrollBar21->Maximum = 255;
			this->hScrollBar21->Minimum = 1;
			this->hScrollBar21->Name = L"hScrollBar21";
			this->hScrollBar21->Size = System::Drawing::Size(228, 19);
			this->hScrollBar21->TabIndex = 89;
			this->hScrollBar21->Value = 150;
			// 
			// label50
			// 
			this->label50->AutoSize = true;
			this->label50->Location = System::Drawing::Point(3, 174);
			this->label50->Name = L"label50";
			this->label50->Size = System::Drawing::Size(34, 13);
			this->label50->TabIndex = 94;
			this->label50->Text = L"CH22";
			// 
			// hScrollBar22
			// 
			this->hScrollBar22->LargeChange = 1;
			this->hScrollBar22->Location = System::Drawing::Point(40, 168);
			this->hScrollBar22->Maximum = 255;
			this->hScrollBar22->Minimum = 1;
			this->hScrollBar22->Name = L"hScrollBar22";
			this->hScrollBar22->Size = System::Drawing::Size(228, 19);
			this->hScrollBar22->TabIndex = 92;
			this->hScrollBar22->Value = 150;
			// 
			// label52
			// 
			this->label52->AutoSize = true;
			this->label52->Location = System::Drawing::Point(3, 201);
			this->label52->Name = L"label52";
			this->label52->Size = System::Drawing::Size(34, 13);
			this->label52->TabIndex = 97;
			this->label52->Text = L"CH23";
			// 
			// hScrollBar23
			// 
			this->hScrollBar23->LargeChange = 1;
			this->hScrollBar23->Location = System::Drawing::Point(40, 195);
			this->hScrollBar23->Maximum = 255;
			this->hScrollBar23->Minimum = 1;
			this->hScrollBar23->Name = L"hScrollBar23";
			this->hScrollBar23->Size = System::Drawing::Size(228, 19);
			this->hScrollBar23->TabIndex = 95;
			this->hScrollBar23->Value = 150;
			// 
			// label54
			// 
			this->label54->AutoSize = true;
			this->label54->Location = System::Drawing::Point(3, 230);
			this->label54->Name = L"label54";
			this->label54->Size = System::Drawing::Size(34, 13);
			this->label54->TabIndex = 100;
			this->label54->Text = L"CH24";
			// 
			// hScrollBar24
			// 
			this->hScrollBar24->LargeChange = 1;
			this->hScrollBar24->Location = System::Drawing::Point(40, 224);
			this->hScrollBar24->Maximum = 255;
			this->hScrollBar24->Minimum = 1;
			this->hScrollBar24->Name = L"hScrollBar24";
			this->hScrollBar24->Size = System::Drawing::Size(228, 19);
			this->hScrollBar24->TabIndex = 98;
			this->hScrollBar24->Value = 150;
			// 
			// label56
			// 
			this->label56->AutoSize = true;
			this->label56->Location = System::Drawing::Point(3, 259);
			this->label56->Name = L"label56";
			this->label56->Size = System::Drawing::Size(34, 13);
			this->label56->TabIndex = 103;
			this->label56->Text = L"CH25";
			// 
			// hScrollBar25
			// 
			this->hScrollBar25->LargeChange = 1;
			this->hScrollBar25->Location = System::Drawing::Point(40, 253);
			this->hScrollBar25->Maximum = 255;
			this->hScrollBar25->Minimum = 1;
			this->hScrollBar25->Name = L"hScrollBar25";
			this->hScrollBar25->Size = System::Drawing::Size(228, 19);
			this->hScrollBar25->TabIndex = 101;
			this->hScrollBar25->Value = 150;
			// 
			// timer1
			// 
			this->timer1->Interval = 1;
			this->timer1->Tick += gcnew System::EventHandler(this, &Form1::timer1_Tick);
			// 
			// deviceChecker
			// 
			this->deviceChecker->Enabled = true;
			this->deviceChecker->Tick += gcnew System::EventHandler(this, &Form1::deviceChecker_Tick);
			// 
			// label17
			// 
			this->label17->AutoSize = true;
			this->label17->Location = System::Drawing::Point(148, 130);
			this->label17->Name = L"label17";
			this->label17->Size = System::Drawing::Size(0, 13);
			this->label17->TabIndex = 104;
			// 
			// panel1
			// 
			this->panel1->Controls->Add(this->groupBox1);
			this->panel1->Controls->Add(this->label17);
			this->panel1->Controls->Add(this->label23);
			this->panel1->Controls->Add(this->label24);
			this->panel1->Controls->Add(this->label25);
			this->panel1->Location = System::Drawing::Point(322, 309);
			this->panel1->Name = L"panel1";
			this->panel1->Size = System::Drawing::Size(301, 146);
			this->panel1->TabIndex = 105;
			// 
			// label12
			// 
			this->label12->AutoSize = true;
			this->label12->Location = System::Drawing::Point(271, 3);
			this->label12->Name = L"label12";
			this->label12->Size = System::Drawing::Size(25, 13);
			this->label12->TabIndex = 106;
			this->label12->Text = L"150";
			// 
			// label13
			// 
			this->label13->AutoSize = true;
			this->label13->Location = System::Drawing::Point(271, 32);
			this->label13->Name = L"label13";
			this->label13->Size = System::Drawing::Size(25, 13);
			this->label13->TabIndex = 107;
			this->label13->Text = L"150";
			// 
			// label14
			// 
			this->label14->AutoSize = true;
			this->label14->Location = System::Drawing::Point(271, 61);
			this->label14->Name = L"label14";
			this->label14->Size = System::Drawing::Size(25, 13);
			this->label14->TabIndex = 108;
			this->label14->Text = L"150";
			// 
			// label15
			// 
			this->label15->AutoSize = true;
			this->label15->Location = System::Drawing::Point(271, 90);
			this->label15->Name = L"label15";
			this->label15->Size = System::Drawing::Size(25, 13);
			this->label15->TabIndex = 109;
			this->label15->Text = L"150";
			// 
			// label16
			// 
			this->label16->AutoSize = true;
			this->label16->Location = System::Drawing::Point(271, 117);
			this->label16->Name = L"label16";
			this->label16->Size = System::Drawing::Size(25, 13);
			this->label16->TabIndex = 110;
			this->label16->Text = L"150";
			// 
			// label18
			// 
			this->label18->AutoSize = true;
			this->label18->Location = System::Drawing::Point(271, 148);
			this->label18->Name = L"label18";
			this->label18->Size = System::Drawing::Size(25, 13);
			this->label18->TabIndex = 111;
			this->label18->Text = L"150";
			// 
			// label19
			// 
			this->label19->AutoSize = true;
			this->label19->Location = System::Drawing::Point(271, 177);
			this->label19->Name = L"label19";
			this->label19->Size = System::Drawing::Size(25, 13);
			this->label19->TabIndex = 112;
			this->label19->Text = L"150";
			// 
			// label20
			// 
			this->label20->AutoSize = true;
			this->label20->Location = System::Drawing::Point(271, 206);
			this->label20->Name = L"label20";
			this->label20->Size = System::Drawing::Size(25, 13);
			this->label20->TabIndex = 113;
			this->label20->Text = L"150";
			// 
			// label27
			// 
			this->label27->AutoSize = true;
			this->label27->Location = System::Drawing::Point(273, 2);
			this->label27->Name = L"label27";
			this->label27->Size = System::Drawing::Size(25, 13);
			this->label27->TabIndex = 114;
			this->label27->Text = L"150";
			// 
			// label29
			// 
			this->label29->AutoSize = true;
			this->label29->Location = System::Drawing::Point(273, 31);
			this->label29->Name = L"label29";
			this->label29->Size = System::Drawing::Size(25, 13);
			this->label29->TabIndex = 115;
			this->label29->Text = L"150";
			// 
			// label31
			// 
			this->label31->AutoSize = true;
			this->label31->Location = System::Drawing::Point(273, 60);
			this->label31->Name = L"label31";
			this->label31->Size = System::Drawing::Size(25, 13);
			this->label31->TabIndex = 116;
			this->label31->Text = L"150";
			// 
			// label33
			// 
			this->label33->AutoSize = true;
			this->label33->Location = System::Drawing::Point(273, 89);
			this->label33->Name = L"label33";
			this->label33->Size = System::Drawing::Size(25, 13);
			this->label33->TabIndex = 117;
			this->label33->Text = L"150";
			// 
			// label35
			// 
			this->label35->AutoSize = true;
			this->label35->Location = System::Drawing::Point(273, 118);
			this->label35->Name = L"label35";
			this->label35->Size = System::Drawing::Size(25, 13);
			this->label35->TabIndex = 118;
			this->label35->Text = L"150";
			// 
			// label37
			// 
			this->label37->AutoSize = true;
			this->label37->Location = System::Drawing::Point(273, 147);
			this->label37->Name = L"label37";
			this->label37->Size = System::Drawing::Size(25, 13);
			this->label37->TabIndex = 119;
			this->label37->Text = L"150";
			// 
			// label39
			// 
			this->label39->AutoSize = true;
			this->label39->Location = System::Drawing::Point(273, 176);
			this->label39->Name = L"label39";
			this->label39->Size = System::Drawing::Size(25, 13);
			this->label39->TabIndex = 120;
			this->label39->Text = L"150";
			// 
			// label41
			// 
			this->label41->AutoSize = true;
			this->label41->Location = System::Drawing::Point(271, 3);
			this->label41->Name = L"label41";
			this->label41->Size = System::Drawing::Size(25, 13);
			this->label41->TabIndex = 121;
			this->label41->Text = L"150";
			// 
			// label43
			// 
			this->label43->AutoSize = true;
			this->label43->Location = System::Drawing::Point(271, 32);
			this->label43->Name = L"label43";
			this->label43->Size = System::Drawing::Size(25, 13);
			this->label43->TabIndex = 122;
			this->label43->Text = L"150";
			// 
			// label45
			// 
			this->label45->AutoSize = true;
			this->label45->Location = System::Drawing::Point(271, 61);
			this->label45->Name = L"label45";
			this->label45->Size = System::Drawing::Size(25, 13);
			this->label45->TabIndex = 123;
			this->label45->Text = L"150";
			// 
			// label47
			// 
			this->label47->AutoSize = true;
			this->label47->Location = System::Drawing::Point(271, 90);
			this->label47->Name = L"label47";
			this->label47->Size = System::Drawing::Size(25, 13);
			this->label47->TabIndex = 124;
			this->label47->Text = L"150";
			// 
			// label49
			// 
			this->label49->AutoSize = true;
			this->label49->Location = System::Drawing::Point(271, 119);
			this->label49->Name = L"label49";
			this->label49->Size = System::Drawing::Size(25, 13);
			this->label49->TabIndex = 125;
			this->label49->Text = L"150";
			// 
			// label51
			// 
			this->label51->AutoSize = true;
			this->label51->Location = System::Drawing::Point(271, 148);
			this->label51->Name = L"label51";
			this->label51->Size = System::Drawing::Size(25, 13);
			this->label51->TabIndex = 126;
			this->label51->Text = L"150";
			// 
			// label53
			// 
			this->label53->AutoSize = true;
			this->label53->Location = System::Drawing::Point(271, 174);
			this->label53->Name = L"label53";
			this->label53->Size = System::Drawing::Size(25, 13);
			this->label53->TabIndex = 127;
			this->label53->Text = L"150";
			// 
			// label55
			// 
			this->label55->AutoSize = true;
			this->label55->Location = System::Drawing::Point(271, 201);
			this->label55->Name = L"label55";
			this->label55->Size = System::Drawing::Size(25, 13);
			this->label55->TabIndex = 128;
			this->label55->Text = L"150";
			// 
			// label57
			// 
			this->label57->AutoSize = true;
			this->label57->Location = System::Drawing::Point(271, 230);
			this->label57->Name = L"label57";
			this->label57->Size = System::Drawing::Size(25, 13);
			this->label57->TabIndex = 129;
			this->label57->Text = L"150";
			// 
			// label58
			// 
			this->label58->AutoSize = true;
			this->label58->Location = System::Drawing::Point(271, 259);
			this->label58->Name = L"label58";
			this->label58->Size = System::Drawing::Size(25, 13);
			this->label58->TabIndex = 130;
			this->label58->Text = L"150";
			// 
			// panel2
			// 
			this->panel2->Controls->Add(this->hScrollBar16);
			this->panel2->Controls->Add(this->label58);
			this->panel2->Controls->Add(this->label38);
			this->panel2->Controls->Add(this->label57);
			this->panel2->Controls->Add(this->hScrollBar17);
			this->panel2->Controls->Add(this->label55);
			this->panel2->Controls->Add(this->label40);
			this->panel2->Controls->Add(this->label53);
			this->panel2->Controls->Add(this->hScrollBar18);
			this->panel2->Controls->Add(this->label51);
			this->panel2->Controls->Add(this->label42);
			this->panel2->Controls->Add(this->label49);
			this->panel2->Controls->Add(this->hScrollBar19);
			this->panel2->Controls->Add(this->label47);
			this->panel2->Controls->Add(this->label44);
			this->panel2->Controls->Add(this->label45);
			this->panel2->Controls->Add(this->hScrollBar20);
			this->panel2->Controls->Add(this->label43);
			this->panel2->Controls->Add(this->label46);
			this->panel2->Controls->Add(this->label41);
			this->panel2->Controls->Add(this->hScrollBar21);
			this->panel2->Controls->Add(this->label48);
			this->panel2->Controls->Add(this->hScrollBar22);
			this->panel2->Controls->Add(this->label50);
			this->panel2->Controls->Add(this->hScrollBar23);
			this->panel2->Controls->Add(this->label52);
			this->panel2->Controls->Add(this->hScrollBar24);
			this->panel2->Controls->Add(this->label54);
			this->panel2->Controls->Add(this->hScrollBar25);
			this->panel2->Controls->Add(this->label56);
			this->panel2->Location = System::Drawing::Point(320, 19);
			this->panel2->Name = L"panel2";
			this->panel2->Size = System::Drawing::Size(315, 276);
			this->panel2->TabIndex = 131;
			// 
			// panel3
			// 
			this->panel3->Controls->Add(this->hScrollBar9);
			this->panel3->Controls->Add(this->label11);
			this->panel3->Controls->Add(this->label39);
			this->panel3->Controls->Add(this->hScrollBar10);
			this->panel3->Controls->Add(this->label37);
			this->panel3->Controls->Add(this->label26);
			this->panel3->Controls->Add(this->label35);
			this->panel3->Controls->Add(this->hScrollBar11);
			this->panel3->Controls->Add(this->label33);
			this->panel3->Controls->Add(this->label28);
			this->panel3->Controls->Add(this->label31);
			this->panel3->Controls->Add(this->hScrollBar12);
			this->panel3->Controls->Add(this->label29);
			this->panel3->Controls->Add(this->label30);
			this->panel3->Controls->Add(this->label27);
			this->panel3->Controls->Add(this->hScrollBar13);
			this->panel3->Controls->Add(this->label32);
			this->panel3->Controls->Add(this->hScrollBar14);
			this->panel3->Controls->Add(this->label34);
			this->panel3->Controls->Add(this->hScrollBar15);
			this->panel3->Controls->Add(this->label36);
			this->panel3->Location = System::Drawing::Point(2, 251);
			this->panel3->Name = L"panel3";
			this->panel3->Size = System::Drawing::Size(314, 199);
			this->panel3->TabIndex = 132;
			// 
			// panel4
			// 
			this->panel4->Controls->Add(this->hScrollBar1);
			this->panel4->Controls->Add(this->hScrollBar2);
			this->panel4->Controls->Add(this->hScrollBar3);
			this->panel4->Controls->Add(this->label20);
			this->panel4->Controls->Add(this->hScrollBar4);
			this->panel4->Controls->Add(this->label19);
			this->panel4->Controls->Add(this->hScrollBar5);
			this->panel4->Controls->Add(this->label18);
			this->panel4->Controls->Add(this->hScrollBar6);
			this->panel4->Controls->Add(this->label16);
			this->panel4->Controls->Add(this->hScrollBar7);
			this->panel4->Controls->Add(this->label15);
			this->panel4->Controls->Add(this->hScrollBar8);
			this->panel4->Controls->Add(this->label14);
			this->panel4->Controls->Add(this->label3);
			this->panel4->Controls->Add(this->label13);
			this->panel4->Controls->Add(this->label4);
			this->panel4->Controls->Add(this->label12);
			this->panel4->Controls->Add(this->label5);
			this->panel4->Controls->Add(this->label6);
			this->panel4->Controls->Add(this->label10);
			this->panel4->Controls->Add(this->label7);
			this->panel4->Controls->Add(this->label9);
			this->panel4->Controls->Add(this->label8);
			this->panel4->Location = System::Drawing::Point(4, 20);
			this->panel4->Name = L"panel4";
			this->panel4->Size = System::Drawing::Size(307, 219);
			this->panel4->TabIndex = 133;
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(644, 479);
			this->Controls->Add(this->panel4);
			this->Controls->Add(this->panel3);
			this->Controls->Add(this->panel2);
			this->Controls->Add(this->panel1);
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->MaximizeBox = false;
			this->Name = L"Form1";
			this->Text = L"Device Server";
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->groupBox1->ResumeLayout(false);
			this->groupBox1->PerformLayout();
			this->panel1->ResumeLayout(false);
			this->panel1->PerformLayout();
			this->panel2->ResumeLayout(false);
			this->panel2->PerformLayout();
			this->panel3->ResumeLayout(false);
			this->panel3->PerformLayout();
			this->panel4->ResumeLayout(false);
			this->panel4->PerformLayout();
			this->ResumeLayout(false);

		}
#pragma endregion

private: void server() {
			 try {
				 //int port =  System::Int32::Parse(textBox1->ToString());
				 int port = 81;
				 IPAddress^ address = IPAddress::Parse(comboBox1->Text);

				 TcpListener^ server = gcnew TcpListener(address,port);

				 server->Start();
			      
				 //This value may need to be larger if the data transmission rate is very slow
				 array<Byte>^bytes = gcnew array<Byte>(1024);
				 String^ data = nullptr;

				array<int>^ values = gcnew array<int>(25); 
				for(int i = 0; i < 25; i++){
					values[i] = 0;
				}
			      
				 while(true) {
					 client = server->AcceptTcpClient();
					 clientConnected = true;

					 data = nullptr;
					 NetworkStream^ stream = client->GetStream();
					 Int32 i;

					 //label2->Text = "Waiting for data...";
					 label2->Text = "Clent connected";
					 			        
					 while(i = stream->Read( bytes, 0, bytes->Length)){

						 //label2->Text = "Receiving data";
						 label2->Text = "Clent connected";
			            
						 data = System::Text::Encoding::ASCII->GetString( bytes, 0, i );

						 //label59->Text = data;
						 //label60->Text = i.ToString();

						 char* token = (char*)(void*)Marshal::StringToHGlobalAnsi(data);
						 char* next_token;

						 char *str2;
						 int index = 0;
						
						 str2 = strtok_s(token, "#", &next_token);

						 while( str2 != NULL ) {
							 try {
								 if(atoi(str2) >= 0 && atoi(str2) <= 255) {
								      values[index] = atoi(str2);
									  index++;
									  if(index > 24){ 
										  index = 0;
									  }
								 }
							 }catch(exception e) { }

							 if(index > 0) {
								 str2 = strtok_s(NULL, "/", &next_token);
							 }
							 else {
								 str2 = strtok_s(NULL, "#", &next_token);
							 }



							 if(index == 0) {

								 //Set Ch1
								 if(values[1] <= hScrollBar1->Maximum && values[1] >= hScrollBar1->Minimum) {
									 hScrollBar1->Value = values[1];
									 label12->Text = hScrollBar1->Value.ToString();
								 }
								 //Set Ch2
								 if(values[2] <= hScrollBar2->Maximum && values[2] >= hScrollBar2->Minimum) {
									 hScrollBar2->Value = values[2];
									 label13->Text = hScrollBar2->Value.ToString();
								 }
								 //Set Ch3
								 if(values[3] <= hScrollBar3->Maximum && values[3] >= hScrollBar3->Minimum) {
									 hScrollBar3->Value = values[3];
									 label14->Text = hScrollBar3->Value.ToString();
								 }
								 //Set Ch4
								 if(values[4] <= hScrollBar4->Maximum && values[4] >= hScrollBar4->Minimum) {
									 hScrollBar4->Value = values[4];
									 label15->Text = hScrollBar4->Value.ToString();
								 }
								 //Set Ch5
								 if(values[5] <= hScrollBar5->Maximum && values[5] >= hScrollBar5->Minimum) {
									 hScrollBar5->Value = values[5];
									 label16->Text = hScrollBar5->Value.ToString();
								 }
								 //Set Ch6
								 if(values[6] <= hScrollBar6->Maximum && values[6] >= hScrollBar6->Minimum) {
									 hScrollBar6->Value = values[6];
									 label18->Text = hScrollBar6->Value.ToString();
								 }

								 //Set Ch7
								 if(values[7] <= hScrollBar7->Maximum && values[7] >= hScrollBar7->Minimum) {
									 hScrollBar7->Value = values[7];
									 label19->Text = hScrollBar7->Value.ToString();
								 }
								 //Set Ch8
								 if(values[8] <= hScrollBar8->Maximum && values[8] >= hScrollBar8->Minimum) {
									 hScrollBar8->Value = values[8];
									 label20->Text = hScrollBar8->Value.ToString();
								 }
								 //Set Ch9
								 if(values[9] <= hScrollBar9->Maximum && values[9] >= hScrollBar9->Minimum) {
									 hScrollBar9->Value = values[9];
									 label27->Text = hScrollBar9->Value.ToString();
								 }
								 //Set Ch10
								 if(values[10] <= hScrollBar10->Maximum && values[10] >= hScrollBar10->Minimum) {
									 hScrollBar10->Value = values[10];
									 label29->Text = hScrollBar10->Value.ToString();
								 }
								 //Set Ch11
								 if(values[11] <= hScrollBar11->Maximum && values[11] >= hScrollBar11->Minimum) {
									 hScrollBar11->Value = values[11];
									 label31->Text = hScrollBar11->Value.ToString();
								 }
								 //Set Ch12
								 if(values[12] <= hScrollBar12->Maximum && values[12] >= hScrollBar12->Minimum) {
									 hScrollBar12->Value = values[12];
									 label33->Text = hScrollBar12->Value.ToString();
								 }
								 //Set Ch13
								 if(values[13] <= hScrollBar13->Maximum && values[13] >= hScrollBar13->Minimum) {
									 hScrollBar13->Value = values[13];
									 label35->Text = hScrollBar13->Value.ToString();
								 }
								 //Set Ch14
								 if(values[14] <= hScrollBar14->Maximum && values[14] >= hScrollBar14->Minimum) {
									 hScrollBar14->Value = values[14];
									 label37->Text = hScrollBar14->Value.ToString();
								 }
								 //Set Ch15
								 if(values[15] <= hScrollBar15->Maximum && values[15] >= hScrollBar15->Minimum) {
									 hScrollBar15->Value = values[15];
									 label39->Text = hScrollBar15->Value.ToString();
								 }
								 //Set Ch16
								 if(values[16] <= hScrollBar16->Maximum && values[16] >= hScrollBar16->Minimum) {
									 hScrollBar16->Value = values[16];
									 label41->Text = hScrollBar16->Value.ToString();
								 }
								 //Set Ch17
								 if(values[17] <= hScrollBar17->Maximum && values[17] >= hScrollBar17->Minimum) {
									 hScrollBar17->Value = values[17];
									 label43->Text = hScrollBar17->Value.ToString();
								 }
								 //Set Ch18
								 if(values[18] <= hScrollBar18->Maximum && values[18] >= hScrollBar18->Minimum) {
									 hScrollBar18->Value = values[18];
									 label41->Text = hScrollBar18->Value.ToString();
								 }
								 //Set Ch19
								 if(values[19] <= hScrollBar19->Maximum && values[19] >= hScrollBar19->Minimum) {
									 hScrollBar19->Value = values[19];
									 label47->Text = hScrollBar19->Value.ToString();
								 }
								 //Set Ch20
								 if(values[20] <= hScrollBar20->Maximum && values[20] >= hScrollBar20->Minimum) {
									 hScrollBar20->Value = values[20];
									 label49->Text = hScrollBar20->Value.ToString();
								 }
								 //Set Ch21
								 if(values[21] <= hScrollBar21->Maximum && values[21] >= hScrollBar21->Minimum) {
									 hScrollBar21->Value = values[21];
									 label51->Text = hScrollBar21->Value.ToString();
								 }
								 //Set Ch22
								 if(values[22] <= hScrollBar22->Maximum && values[22] >= hScrollBar22->Minimum) {
									 hScrollBar22->Value = values[22];
									 label53->Text = hScrollBar22->Value.ToString();
								 }
								 //Set Ch23
								 if(values[23] <= hScrollBar23->Maximum && values[23] >= hScrollBar23->Minimum) {
									 hScrollBar23->Value = values[23];
									 label55->Text = hScrollBar23->Value.ToString();
								 }
								 //Set Ch24
								 if(values[24] <= hScrollBar24->Maximum && values[24] >= hScrollBar24->Minimum) {
									 hScrollBar24->Value = values[24];
									 label57->Text = hScrollBar24->Value.ToString();
								 }
								 //Set Ch25
								 if(values[0] <= hScrollBar25->Maximum && values[0] >= hScrollBar25->Minimum) {
									 hScrollBar25->Value = values[0];
									 label58->Text = hScrollBar25->Value.ToString();
								 }

								 if(c->connected){
									 c->send(hScrollBar1->Value,hScrollBar2->Value,hScrollBar3->Value,hScrollBar4->Value,hScrollBar5->Value,hScrollBar6->Value,hScrollBar7->Value,hScrollBar8->Value,hScrollBar9->Value,hScrollBar10->Value,hScrollBar11->Value,hScrollBar12->Value,
										hScrollBar13->Value,hScrollBar14->Value,hScrollBar15->Value,hScrollBar16->Value,hScrollBar17->Value,hScrollBar18->Value,hScrollBar19->Value,hScrollBar20->Value,hScrollBar21->Value,hScrollBar22->Value,hScrollBar23->Value,hScrollBar24->Value,hScrollBar25->Value);
								 }
								 }
						 }

						 //_sleep(100);			//for simulating a slow network on a fast network
					 }

					 client->Close();
					 label2->Text = "Clent disconnected";
					 clientConnected = false;

					 //check to see what type of device is connected then enable the scrollbars
					 checkAndSet();

					 timer1->Enabled = true;
				 }
			 }
			 catch (SocketException^ e){
				 //label2->Text = "Server IP Incorrect!";
			 }
		 }

	private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) {
				 //find all the ip's on the pc
				 String ^strHostName = gcnew String ("");
				 strHostName = Dns::GetHostName();								//get localhost
				 IPHostEntry ^ipEntry = Dns::GetHostEntry(strHostName);
		          
				 for (int i = 0; i < ipEntry->AddressList->Length; i++) {
					comboBox1->Items->Add(ipEntry->AddressList[i]->ToString());
				 }

				 comboBox1->SelectedIndex = 0;									//choose the first ip by default, the user can change later


				 //connect to the output device
				 c = new controller();
				 if(c->connected){
					 label25->Visible = true;	//green on
					 label24->Visible = false;	//red off
				 }
				 else {
					 label24->Visible = true;	//red on 
					 label25->Visible = false;	//green off
				 }

				 //disable all scrollbars
				 //disableAll();

				 clientConnected = false;
			 }


		 //Start the server
private: System::Void button1_Click(System::Object^  sender, System::EventArgs^  e) {
			 timer1->Enabled = false;		//stop sending data from the scrollbars

			 button1->Enabled = false;
			 button2->Enabled = true;

			 //put the server function in a thread to wait for incomming connections
			 ThreadStart ^mainthread = gcnew ThreadStart(this, &serverGui::Form1::server);
			 trd = gcnew Thread(mainthread);
			 trd->IsBackground = true;
			 trd->Start();	

			 //disable all scrollbars
			 //disableAll();
		 }


		 //Stop the server (not currently enabled)
private: System::Void button2_Click(System::Object^  sender, System::EventArgs^  e) {
			 if(clientConnected){
				client->Close();
			 }
			 trd->Interrupt();
			 //trd->Abort();
			 //trd->Suspend();
			 
			 button1->Enabled = true;
			 button2->Enabled = false;

			 timer1->Enabled = true;		//start sending data from the scrollbars

			 //checkAndSet();
		 }


private: System::Void timer1_Tick(System::Object^  sender, System::EventArgs^  e) {
			 if(c->connected){
				 label12->Text = hScrollBar1->Value.ToString();
				 label13->Text = hScrollBar2->Value.ToString();
				 label14->Text = hScrollBar3->Value.ToString();
				 label15->Text = hScrollBar4->Value.ToString();
				 label16->Text = hScrollBar5->Value.ToString();
				 label18->Text = hScrollBar6->Value.ToString();
				 label19->Text = hScrollBar7->Value.ToString();
				 label20->Text = hScrollBar8->Value.ToString();
				 label27->Text = hScrollBar9->Value.ToString();
				 label29->Text = hScrollBar10->Value.ToString();
				 label31->Text = hScrollBar11->Value.ToString();
				 label33->Text = hScrollBar12->Value.ToString();
				 label35->Text = hScrollBar13->Value.ToString();
				 label37->Text = hScrollBar14->Value.ToString();
				 label39->Text = hScrollBar15->Value.ToString();
				 label41->Text = hScrollBar16->Value.ToString();
				 label43->Text = hScrollBar17->Value.ToString();
				 label41->Text = hScrollBar18->Value.ToString();
				 label47->Text = hScrollBar19->Value.ToString();
				 label49->Text = hScrollBar20->Value.ToString();
				 label51->Text = hScrollBar21->Value.ToString();
				 label53->Text = hScrollBar22->Value.ToString();
				 label55->Text = hScrollBar23->Value.ToString();
				 label57->Text = hScrollBar24->Value.ToString();
				 label58->Text = hScrollBar25->Value.ToString();

				 c->send(hScrollBar1->Value,hScrollBar2->Value,hScrollBar3->Value,hScrollBar4->Value,hScrollBar5->Value,hScrollBar6->Value,hScrollBar7->Value,hScrollBar8->Value,hScrollBar9->Value,hScrollBar10->Value,hScrollBar11->Value,hScrollBar12->Value,
					hScrollBar13->Value,hScrollBar14->Value,hScrollBar15->Value,hScrollBar16->Value,hScrollBar17->Value,hScrollBar18->Value,hScrollBar19->Value,hScrollBar20->Value,hScrollBar21->Value,hScrollBar22->Value,hScrollBar23->Value,hScrollBar24->Value,hScrollBar25->Value);
			 }
		 }


//check for a PCTx or 25 Servo Controller
private: System::Void deviceChecker_Tick(System::Object^  sender, System::EventArgs^  e) {
				System::String ^text;
				if (c->checkStatus()){
					label24->Visible = false; //red off
					label25->Visible = true; //green on

					//checkAndSet();
				}
				else {
					if(c->connect()) {
						label24->Visible = false;		//red off
						label25->Visible = true;		//green on

						//checkAndSet();
					}
					else {
						label24->Visible = true;		//red on
						label25->Visible = false;		//green off

						//checkAndSet();
					}
				}
		 }

		 void disableAll(){
			panel2->Enabled = false;
			panel3->Enabled = false;
			panel4->Enabled = false;
		 }

		 void checkAndSet(){
			 System::String ^text;
			 text = gcnew System::String(c->hidName);
			 if(text->Equals("2")) {		//25SC
				panel2->Enabled = true;
				panel3->Enabled = true;
				panel4->Enabled = true;

				label17->Text = "25 Servo Controller";

				button1->Enabled = true;
			 }
			 else if(text->Equals("P")) {	//PCTx
				panel4->Enabled = true;	
				panel2->Enabled = false;
				panel3->Enabled = false;

				label17->Text = "PCTx";

				button1->Enabled = true;
			 }
			 else {							//Nothing
				panel2->Enabled = false;
				panel3->Enabled = false;
				panel4->Enabled = false;

				label17->Text = "No Device Connected";

				button1->Enabled = false;
			 }
		 }
};
}